function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(n); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { return function () { var Super = _getPrototypeOf(Derived), result; if (_isNativeReflectConstruct()) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React, { Component } from 'react';
import { withRouter } from 'react-router-dom';
import PropTypes from 'prop-types';
import { setThemeColor, checkAuth, getClientHeight } from 'ehome-utils';
import Blank from '../blank';

var Authcomponent = /*#__PURE__*/function (_Component) {
  _inherits(Authcomponent, _Component);

  var _super = _createSuper(Authcomponent);

  function Authcomponent(props) {
    var _this;

    _classCallCheck(this, Authcomponent);

    _this = _super.call(this, props);
    _this.state = {
      showPage: false,
      message: ''
    };
    return _this;
  }

  _createClass(Authcomponent, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      /** 进行鉴权操作 */
      var _this$props = this.props,
          initHeight = _this$props.initHeight,
          setTheme = _this$props.setTheme,
          extraFunc = _this$props.extraFunc;
      var checkAuthFuc = [checkAuth()];
      initHeight && checkAuthFuc.push(getClientHeight());
      setTheme && checkAuthFuc.push(setThemeColor());

      if (extraFunc) {
        extraFunc instanceof Array ? checkAuthFuc.push.apply(checkAuthFuc, _toConsumableArray(extraFunc)) : checkAuthFuc.push(extraFunc);
      }

      Promise.all(checkAuthFuc).then(function () {
        // 第三方处理
        var handleThreeWeb = _this2.props.handleThreeWeb;

        if (window.$$env === 'THREEWEB') {
          if (handleThreeWeb) {
            handleThreeWeb();
          } else {
            _this2.setState({
              message: '授权失败,请稍后再试'
            });

            return;
          }
        }

        var sourceHash = window.location.hash;
        var realHash = ''; // 如果 url 带有授权参数则将授权参数去掉

        if (sourceHash.includes('signature') && sourceHash.includes('appKey')) {
          var signatureIndex = sourceHash.indexOf('&');
          realHash = sourceHash.substring(2, signatureIndex);
        } else {
          realHash = sourceHash.substring(2);
        }

        _this2.props.history.replace(realHash);

        _this2.setState({
          showPage: true
        });
      })["catch"](function (res) {
        _this2.setState({
          message: res.errorMsg || '授权失败,请稍后再试'
        });
      });
    }
  }, {
    key: "render",
    value: function render() {
      var prefixCls = 'eh-authcomponent';
      var _this$state = this.state,
          showPage = _this$state.showPage,
          message = _this$state.message;
      var content = '';

      if (showPage) {
        content = this.props.children;
      } else {
        content = /*#__PURE__*/React.createElement(Blank, {
          content: message
        });
      }

      return /*#__PURE__*/React.createElement("div", {
        className: prefixCls
      }, content);
    }
  }]);

  return Authcomponent;
}(Component);

_defineProperty(Authcomponent, "propTypes", {
  handleThreeWeb: PropTypes.func,
  initHeight: PropTypes.bool,
  setTheme: PropTypes.bool,
  extraFunc: PropTypes.func
});

_defineProperty(Authcomponent, "defaultProps", {
  initHeight: false,
  setTheme: false
});

export default withRouter(Authcomponent);